from Numeric import array, resize, add, minimum
from pygame import draw, Surface
from pygame.surfarray import array3d, pixels3d, array_alpha, pixels_alpha #blit_array
from pygame.locals import SRCALPHA

def make_array(value, *shape):
	a = array([value])
	return resize(a, shape)

def frame_rect(surface, color, rect, thick = 1):
	surface.fill(color, (rect.left, rect.top, rect.width, thick))
	surface.fill(color, (rect.left, rect.bottom - thick, rect.width, thick))
	surface.fill(color, (rect.left, rect.top, thick, rect.height))
	surface.fill(color, (rect.right - thick, rect.top, thick, rect.height))

def blit_tinted(surface, image, pos, tint, src_rect = None):
	if src_rect:
		image = image.subsurface(src_rect)
	buf = Surface(image.get_size(), SRCALPHA, 32)
	buf.blit(image, (0, 0))
	src_rgb = array3d(image)
	buf_rgb = pixels3d(buf)
	buf_rgb[...] = minimum(255, add(tint, src_rgb)).astype('b')
	buf_rgb = buf_alpha = None
	surface.blit(buf, pos)
